#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <QWidget>
#include <QFileSystemModel>
#include <QDir>
#include <QThread>

namespace Ui {
class MainWidget;
}

class BackupWorker : public QThread
{
  Q_OBJECT
public:
  explicit BackupWorker(QObject* parent = 0);
  ~BackupWorker();
  QString sDir;
  QString dDir;
public slots:
  void runBackup(QString sPath, QString dPath);
signals:
  void backupFinished();
private:
  //Ищет отсутствующие или неактуальные элементы в резервной директории
  void contentDifference(QDir &sDir, QDir &dDir, QFileInfoList &diffList);
  //Наполняет список всех вложенных директорий и файлов
  void recursiveContentList(QDir &dir, QFileInfoList &contentList);

  // QThread interface
protected:
  virtual void run();
};

class MainWidget : public QWidget
{
  Q_OBJECT

public:
  explicit MainWidget(QWidget *parent = 0);
  ~MainWidget();
private slots:
  void on_lvSource_doubleClicked(const QModelIndex &index);
  void on_btnBackup_clicked();
  void readyToStart();
signals:

private:
  Ui::MainWidget *ui;
  QFileSystemModel *model;
  BackupWorker *worker;

};

#endif // MAINWIDGET_H
